{
  "nbformat": 4,
  "nbformat_minor": 0,
  "metadata": {
    "colab": {
      "provenance": []
    },
    "kernelspec": {
      "name": "python3",
      "display_name": "Python 3"
    },
    "language_info": {
      "name": "python"
    }
  },
  "cells": [
    {
      "cell_type": "code",
      "execution_count": 1,
      "metadata": {
        "colab": {
          "base_uri": "https://localhost:8080/"
        },
        "id": "twkBLsy00yvL",
        "outputId": "00d8f995-2042-4070-d7f0-9a6037ae1848"
      },
      "outputs": [
        {
          "name": "stdout",
          "output_type": "stream",
          "text": [
            "   |   |   \n",
            " 7 | 8 | 9 \n",
            "   |   |   \n",
            "-----------\n",
            "   |   |   \n",
            " 4 | 5 | 6 \n",
            "   |   |   \n",
            "-----------\n",
            "   |   |   \n",
            " 1 | 2 | 3 \n",
            "   |   |   \n",
            "Player: Please enter your choice (X,O): 0\n",
            "Player: Please enter your choice (X,O): o\n",
            "Player goes first\n",
            "Pick your position (1-9): 6\n",
            "   |   |   \n",
            " 7 | 8 | 9 \n",
            "   |   |   \n",
            "-----------\n",
            "   |   |   \n",
            " 4 | 5 | O \n",
            "   |   |   \n",
            "-----------\n",
            "   |   |   \n",
            " 1 | 2 | 3 \n",
            "   |   |   \n",
            "AI Position: 5\n",
            "   |   |   \n",
            " 7 | 8 | 9 \n",
            "   |   |   \n",
            "-----------\n",
            "   |   |   \n",
            " 4 | X | O \n",
            "   |   |   \n",
            "-----------\n",
            "   |   |   \n",
            " 1 | 2 | 3 \n",
            "   |   |   \n",
            "Pick your position (1-9): 3\n",
            "   |   |   \n",
            " 7 | 8 | 9 \n",
            "   |   |   \n",
            "-----------\n",
            "   |   |   \n",
            " 4 | X | O \n",
            "   |   |   \n",
            "-----------\n",
            "   |   |   \n",
            " 1 | 2 | O \n",
            "   |   |   \n",
            "AI Position: 9\n",
            "   |   |   \n",
            " 7 | 8 | X \n",
            "   |   |   \n",
            "-----------\n",
            "   |   |   \n",
            " 4 | X | O \n",
            "   |   |   \n",
            "-----------\n",
            "   |   |   \n",
            " 1 | 2 | O \n",
            "   |   |   \n",
            "Pick your position (1-9): 1\n",
            "   |   |   \n",
            " 7 | 8 | X \n",
            "   |   |   \n",
            "-----------\n",
            "   |   |   \n",
            " 4 | X | O \n",
            "   |   |   \n",
            "-----------\n",
            "   |   |   \n",
            " O | 2 | O \n",
            "   |   |   \n",
            "AI Position: 2\n",
            "   |   |   \n",
            " 7 | 8 | X \n",
            "   |   |   \n",
            "-----------\n",
            "   |   |   \n",
            " 4 | X | O \n",
            "   |   |   \n",
            "-----------\n",
            "   |   |   \n",
            " O | X | O \n",
            "   |   |   \n",
            "Pick your position (1-9): 8\n",
            "   |   |   \n",
            " 7 | O | X \n",
            "   |   |   \n",
            "-----------\n",
            "   |   |   \n",
            " 4 | X | O \n",
            "   |   |   \n",
            "-----------\n",
            "   |   |   \n",
            " O | X | O \n",
            "   |   |   \n",
            "AI Position: 7\n",
            "   |   |   \n",
            " X | O | X \n",
            "   |   |   \n",
            "-----------\n",
            "   |   |   \n",
            " 4 | X | O \n",
            "   |   |   \n",
            "-----------\n",
            "   |   |   \n",
            " O | X | O \n",
            "   |   |   \n",
            "Pick your position (1-9): 4\n",
            "   |   |   \n",
            " X | O | X \n",
            "   |   |   \n",
            "-----------\n",
            "   |   |   \n",
            " O | X | O \n",
            "   |   |   \n",
            "-----------\n",
            "   |   |   \n",
            " O | X | O \n",
            "   |   |   \n",
            "It's a tie\n",
            "Do you want to play again (Y/N): n\n"
          ]
        }
      ],
      "source": [
        "#---------------LOGIC------------------#\n",
        "#Check for CPU win move\n",
        "#Check for player win move\n",
        "#Check for CPU fork opportunity\n",
        "#Check for plyaer fork opportunity, but choose to force a block if there are two potential forks\n",
        "#Check center\n",
        "#Check Corners\n",
        "#Check Sides\n",
        "\n",
        "#Display board\n",
        "def display_board(choice_list):\n",
        "    row9 = \"   |   |   \"\n",
        "    row8 = f\" {choice_list[7]} | {choice_list[8]} | {choice_list[9]} \"\n",
        "    row7 = \"   |   |   \"\n",
        "    row6 = \"   |   |   \"\n",
        "    row5 = f\" {choice_list[4]} | {choice_list[5]} | {choice_list[6]} \"\n",
        "    row4 = \"   |   |   \"\n",
        "    row3 = \"   |   |   \"\n",
        "    row2 = f\" {choice_list[1]} | {choice_list[2]} | {choice_list[3]} \"\n",
        "    row1 = \"   |   |   \"\n",
        "    separate_line = \"-----------\"\n",
        "    print(row9)\n",
        "    print(row8)\n",
        "    print(row7)\n",
        "    print(separate_line)\n",
        "    print(row6)\n",
        "    print(row5)\n",
        "    print(row4)\n",
        "    print(separate_line)\n",
        "    print(row3)\n",
        "    print(row2)\n",
        "    print(row1)\n",
        "\n",
        "#player pick what marker they want\n",
        "def marker():\n",
        "    choice = \"Wrong\"\n",
        "    while choice not in [\"X\",\"O\"]:\n",
        "        choice = input(\"Player: Please enter your choice (X,O): \").upper()\n",
        "    if choice == \"X\":\n",
        "        return (\"X\",\"O\")\n",
        "    else:\n",
        "        return (\"O\",\"X\")\n",
        "\n",
        "#Pick who's turn randomly\n",
        "def random_turn():\n",
        "    from random import randint\n",
        "    if randint(1,2) == 1:\n",
        "        print (f\"Player goes first\")\n",
        "        return \"Player\"\n",
        "    else:\n",
        "        print (\"AI goes first\")\n",
        "        return \"AI\"\n",
        "\n",
        "#draws the marker on the position player pick\n",
        "def player_pick_position(choice_list,marker):\n",
        "    position = \"11\"\n",
        "    while (int(position) not in range(1,10)) or choice_list[int(position)]==\"X\" or choice_list[int(position)]==\"O\":\n",
        "        position = input(\"Pick your position (1-9): \")\n",
        "        if int(position) not in range(1,10):\n",
        "            print(\"Please enter valid position (1-9)\")\n",
        "            continue\n",
        "        if choice_list[int(position)]==\"X\" or choice_list[int(position)]==\"O\":\n",
        "            print(\"This position is occupied\")\n",
        "            \n",
        "    choice_list[int(position)] = marker\n",
        "\n",
        "#draws the marker on the position AI pick\n",
        "def AI_pick_position(choice_list,marker,position):\n",
        "    choice_list[position] = marker\n",
        "\n",
        "#logic of detecting winning\n",
        "def detect_win(choice_list):\n",
        "    return (\n",
        "    choice_list[1]==choice_list[2]==choice_list[3] or \n",
        "    choice_list[4]==choice_list[5]==choice_list[6] or \n",
        "    choice_list[7]==choice_list[8]==choice_list[9] or \n",
        "    choice_list[1]==choice_list[5]==choice_list[9] or\n",
        "    choice_list[3]==choice_list[5]==choice_list[7] or \n",
        "    choice_list[1]==choice_list[4]==choice_list[7] or\n",
        "    choice_list[2]==choice_list[5]==choice_list[8] or\n",
        "    choice_list[3]==choice_list[6]==choice_list[9])\n",
        "\n",
        "#if board is full\n",
        "def check_full_board(choice_list):\n",
        "    for index in range(1,10):\n",
        "        if choice_list[index] not in [\"X\",\"O\"]:\n",
        "            return False\n",
        "    return True\n",
        "\n",
        "def empty_position(choice_list):\n",
        "    #All the empty position\n",
        "    index_list = []\n",
        "    for index in range(1,10):\n",
        "        if choice_list[index]!=\"X\" and choice_list[index]!=\"O\":\n",
        "            index_list.append(index)\n",
        "    return index_list\n",
        "\n",
        "#Test if the position makes a FORK situation\n",
        "def testForkMove(choice_list,mark,position):\n",
        "    #Make a copy of the list\n",
        "    copy_list = choice_list[:]\n",
        "\n",
        "    #Mark the position\n",
        "    copy_list[position] = mark\n",
        "    new_copy_list = copy_list[:]\n",
        "\n",
        "    #A list of empty position\n",
        "    empty_list = empty_position(copy_list)\n",
        "\n",
        "    #Count how many possible winning moves\n",
        "    count = 0\n",
        "\n",
        "    #Check all other empty positions\n",
        "    for index in empty_list:\n",
        "        copy_list[index]=mark\n",
        "        if detect_win(copy_list):\n",
        "            count+=1\n",
        "            copy_list = new_copy_list[:]\n",
        "        else:\n",
        "            copy_list = new_copy_list[:]\n",
        "    \n",
        "    #return True if that position makes FORK situation\n",
        "    return (count>=2)\n",
        "\n",
        "#Return AI position\n",
        "def AI_check(choice_list,AI_choice,player_choice):\n",
        "    from random import randint\n",
        "    import random\n",
        "\n",
        "    #The list that will be tested throughout the function\n",
        "    copy_list = choice_list[:]\n",
        "\n",
        "    #All the empty position\n",
        "    empty_list = empty_position(choice_list)\n",
        "\n",
        "    #AI can win, return the position\n",
        "    for position in empty_list:\n",
        "        copy_list[position] = AI_choice\n",
        "        if detect_win(copy_list):\n",
        "            return position\n",
        "        else:\n",
        "            #Make sure the copy_list is setback to original list\n",
        "            copy_list = choice_list[:]\n",
        "\n",
        "    #Player can win, return the position\n",
        "    for position in empty_list:\n",
        "        copy_list[position] = player_choice\n",
        "        if detect_win(copy_list):\n",
        "            return position\n",
        "        else:\n",
        "            copy_list = choice_list[:]\n",
        "\n",
        "    #Check if AI can make FORK situation\n",
        "    for position in empty_list:\n",
        "        if (testForkMove(copy_list,AI_choice,position)==True):\n",
        "            return position\n",
        "    \n",
        "    #Check if player can make FORK situation, \n",
        "    # if two then block, but check don't make the player to form a fork again\n",
        "    player_fork_count = 0\n",
        "    FORK_position = []\n",
        "    for position in empty_list:\n",
        "        if testForkMove(copy_list,player_choice,position)==True:\n",
        "            player_fork_count+=1\n",
        "            FORK_position.append(position)\n",
        "\n",
        "    #Prevent player to form the FORK\n",
        "    if player_fork_count == 1:\n",
        "        return FORK_position[0]\n",
        "    \n",
        "    #The player has more than one position to form the FORK\n",
        "    #Make the player to block, but not on the FORK position\n",
        "    elif player_fork_count>=2:\n",
        "        for index in empty_list:\n",
        "            copy_list[index]=AI_choice\n",
        "            #The list with AI marked the trial position\n",
        "            new_copy_list = copy_list[:]\n",
        "            #The empty list after the AI marked the trial position\n",
        "            new_empty_list = empty_position(copy_list)\n",
        "            for position in new_empty_list:\n",
        "                copy_list[position]=AI_choice\n",
        "                if detect_win(copy_list) and position not in FORK_position:\n",
        "                    return index\n",
        "                else:\n",
        "                    copy_list = new_copy_list[:]\n",
        "            copy_list = choice_list[:]\n",
        "    \n",
        "    #if player has no winning potential, no fork potential\n",
        "   \n",
        "    #Play Center\n",
        "    if choice_list[5]!=\"X\" and choice_list[5]!=\"O\":\n",
        "        return 5\n",
        "    #Play Corner\n",
        "    Corner = [1,3,7,9]\n",
        "    for i in random.sample(Corner,4):\n",
        "        if (choice_list[i]!=\"X\" and choice_list[i]!=\"O\"):\n",
        "            return i\n",
        "    #Play Side\n",
        "    Side = [2,4,6,8]\n",
        "    for i in random.sample(Side,4):\n",
        "        if (choice_list[i]!=\"X\" and choice_list[i]!=\"O\"):\n",
        "            return i\n",
        "\n",
        "\n",
        "#Ask for another game\n",
        "def gameon():\n",
        "    gameon = \"default\"\n",
        "    while gameon!='Y' and gameon!='N':\n",
        "        gameon = input(\"Do you want to play again (Y/N): \").upper()\n",
        "        if gameon == \"Y\":\n",
        "            return True\n",
        "        if gameon == \"N\":\n",
        "            return False\n",
        "        else:\n",
        "            print(\"Please enter Y or N\")\n",
        "\n",
        "#game logic\n",
        "while True:\n",
        "    choice_list = [\"#\",\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\"]\n",
        "    display_board(choice_list)\n",
        "    #Pick the marker\n",
        "    (player_choice,AI_choice) = marker()\n",
        "    turn = random_turn()\n",
        "    while True:\n",
        "        if turn == \"Player\":\n",
        "            player_pick_position(choice_list,player_choice)\n",
        "            display_board(choice_list)\n",
        "            if detect_win(choice_list):\n",
        "                print(\"Congratulation! You win!\")\n",
        "                break\n",
        "                \n",
        "            elif check_full_board(choice_list):\n",
        "                print(\"It's a tie\")\n",
        "                break\n",
        "                \n",
        "            else:\n",
        "                turn = \"AI\"\n",
        "        else:\n",
        "            AI_position = AI_check(choice_list,AI_choice,player_choice) #return position\n",
        "            AI_pick_position(choice_list,AI_choice,AI_position)\n",
        "            print(f\"AI Position: {AI_position}\")\n",
        "            display_board(choice_list)\n",
        "            if detect_win(choice_list):\n",
        "                print(\"You Suck, AI win\")\n",
        "                break\n",
        "                \n",
        "            elif check_full_board(choice_list):\n",
        "                print(\"It's a tie\")\n",
        "                break\n",
        "                \n",
        "            else:\n",
        "                turn = \"Player\"\n",
        "    if gameon()==False:\n",
        "        break"
      ]
    }
  ]
}